<?php
/*
Plugin Name: Simple Extra Inputs
Description: Adds additional user inputs where required in the theme.
Version: 1.2
Author: Jason Dixon
Author URI: http://simpleextrainputs.internetimagery.com
*/

/*	---------------------------------------------------------------------------------
*	IF YOU WISH TO CHANGE THE COLOUR OF THE CURRENTLY ACTIVE TAB, EDIT THIS VARIABLE.
*	---------------------------------------------------------------------------------*/
	$SEI_CURRENTLY_ACTIVE_TAB = '#96f4b4';
/*	---------------------------------------------------------------------------------*/

/*	---------------------------------------------------------------------------------
*	IF YOU WANT TO GIVE PERMISSION TO HAVE PLUGINS PLACE DATA ON TOP OR BELOW YOUR
*	!!EXTRA!! CONTENT, MAKE THESE VALUES TRUE. (PLUGINS CAN STILL PLACE DATA ABOVE OR
*	BELOW YOUR 'MAIN' CONTENT SECTION REGARDLESS OF THIS SETTING.
*	---------------------------------------------------------------------------------*/
	$SEI_CONTENT_TOP	= false;
	$SEI_CONTENT_BOTTOM	= false;
/*	---------------------------------------------------------------------------------*/


# get correct id for plugin
$thisfile=basename(__FILE__, '.php');

# register plugin
register_plugin(
	$thisfile, //Plugin id
	'Simple Extra Inputs', 	//Plugin name
	'1.0', 		//Plugin version
	'Jason Dixon',  //Plugin author
	'http://simpleextrainputs.internetimagery.com', //author website
	'Adds additional user inputs where required in the theme', //Plugin description
	'', //page type - on which admin tab to display
	''  //main function (administration)
);
// Sort out hooks.
add_action('edit-extras','page_edit_box');//					Process content and choose which data to display.
add_action('edit-content','page_edit_foot');//					Add some new page tabs below the content edit box.
add_action('changedata-save','intercept_save_file');//				Intercept file save before it is saved.
add_filter('content','content_hostage');//					Intercept content before it is put to page.

/*	---------------------------------------------------------------------------------
*	Functions below are reserved for use in template files by template creators.
*	The idea is to have the option to keep consistency by using a naming convention.
*	You can still use GetSimpleCMS's normal functions, and they will do what they have always done.
*	get_page_content($slug) functions differently to insert_page_content($field) however.
*	---------------------------------------------------------------------------------*/

function insert_page_content($field = NULL){//					Output users content to page
	global $SEI_CONTENT_BOTTOM;//						Use -> to output a different pages content.
	global $SEI_CONTENT_TOP;
	global $content;
	if(!array_key_exists('SEI_RAW_CONTENT_DATA', $GLOBALS)){
		$content = strip_decode($content);
		global $SEI_RAW_CONTENT_DATA;
		$SEI_RAW_CONTENT_DATA = scan_content_string($content);}
	else {global $SEI_RAW_CONTENT_DATA;}
	$field = array_map('trim', explode('->',$field));
	if($field[0]==NULL || count($SEI_RAW_CONTENT_DATA)==1 || bling($field[0])=='Main' || $SEI_RAW_CONTENT_DATA == false){get_page_content(); return;}
	if($SEI_CONTENT_TOP == true){exec_action('content-top');}
		if(count($field) == 2){
		$data = strip_decode(hunt_page_data($field[0], $field[1]));
		echo exec_filter('content',$data);}
	else { $field = bling($field[0]);
	if (array_key_exists($field, $SEI_RAW_CONTENT_DATA)){
		$data = $SEI_RAW_CONTENT_DATA[$field];
		echo exec_filter('content',$data);}
	else { echo 'Error 404: Your content is not here!';}}
	if($SEI_CONTENT_BOTTOM == true){exec_action('content-bottom');}
}
function insert_page_header(){//						Output header information

	get_page_header();
}
function insert_page_footer(){//						Output footer information

	get_page_footer();
}
function insert_page_navigation($nav=NULL){//					Output page navigation

	get_navigation($nav);
}	/*-------------------------------------------------------------------------------*/


/*	---------------------------------------------------------------------------------
*	Triggers that happen on the page edit screen.
*	Saving page information to file and recording the tab last used etc.
*	---------------------------------------------------------------------------------*/
function page_edit_box(){//							Process data and display in the editor.

	global $SEI_LAST_TAB;//							Set a page to come back to after saving.
	global $SEI_TAB_LIST;//							Initialize our tab list.
	global $SEI_WARNING;//							Warning message.
	global $data_edit;//							Grab the XML page file.
	global $TEMPLATE;//							Get theme folder.
	global $template;//							Get theme file.
	global $content;//							Get page content.
	$SEI_WARNING = 0;//							Preemptively set it to false. Warnings suck!

	$raw_tab_list = scan_template($TEMPLATE,$template);//			Scan the template folder, gather content requests.
	$SEI_TAB_LIST = array();//						Make sure the tab list is an array and empty.
	foreach($raw_tab_list as $tab){//					Run through the list. Validate it all.
		$tab = array_map('trim', explode('->',$tab));
		if (count($tab) == 1){//					Check for -> function. Don't process if it is there.
		if($tab[0] == NULL){//						Run through and clean up.
			$tab[0] = 'Main';}//					Default value for empty brackets is "Main".
		if(!preg_match('/^[\w_-\s]+$/',$tab[0])){//			Check the tab if it has illegal characters.
		$SEI_WARNING = 2;//						Warn that the tab is illegal.
		} else {
		$tab = bling($tab[0]);//					Make tabs pretty!
		$tab = safe_slash_html($tab);//					Make tabs safe.
		if(in_array($tab, $SEI_TAB_LIST)){//				Check for duplicates.
			$SEI_WARNING = 1;}//					Trigger duplicate warning.
		else { array_push($SEI_TAB_LIST,$tab);//			Add tab to the list.
		}}}}
	if(isset($data_edit->returnpage)){//					Check to see if a return page exists.
	$SEI_LAST_TAB = (string)$data_edit->returnpage;//			If not, then set it to the default "main".
	} else {$SEI_LAST_TAB = 'Main';}
	if(!in_array($SEI_LAST_TAB,$SEI_TAB_LIST)){//				Check to see if the return tab is in the template.
		$SEI_LAST_TAB = $SEI_TAB_LIST[0];}//				If not, then swap to a relevant tab.

	echo '<!--- Added by the Simple Extra Inputs plugin. --->'."\n";//	Store record of the last tab viewed.
	echo '<input type="hidden" name="lastpage-view" value="'.safe_slash_html($SEI_LAST_TAB).'">';
	//									Store raw content data for retrieval later.
	echo '<input type="hidden" name="old-page-content" value="'.safe_slash_html($content).'">';

	$display_content = scan_content_string($content);//			Extract the data from the page xml file.
	if($display_content == false && $content == NULL){//			If the page is fresh add in welcome message.
		$content = '<p></p><h1>Welcome to your new page!</h1><p>Remove this text and add your content here. Below are some named Tabs. Click them to switch editing between different sections of your web page. Don\' forget to add a title to your page, above.</p>';
		} elseif($display_content == false){//				Check if it's an old page not yet converted.
		$content = $content;} else {//					Leave the content alone. Otherwise if there is data,
	$content = $display_content[$SEI_LAST_TAB];}//				pick the correct tab data to display to the user.
	if(trim($content) == NULL){//						If the content is a new tab, throw in a message.
		$content = 'Add your text or images for the "'.$SEI_LAST_TAB.'" section:';}
}
function page_edit_foot(){//							Print out tabs below the text input box.

	global $SEI_CURRENTLY_ACTIVE_TAB;//					Get the active tab style.
	global $SEI_LAST_TAB;//							Get the active tab name.
	global $SEI_TAB_LIST;//							Get the list of tab names.
	global $SEI_WARNING;//							Check the warning.

	if($SEI_WARNING != 0){echo '<div class="updated">WARNING! ';//Is there a warning?
	if($SEI_WARNING == 1){//						There is a duplicate tab in the theme.
	echo 'Your selected template has duplicate input requests.';}
	if($SEI_WARNING == 2){//						There are illegal tabs hidden.
	echo 'There are one or more tabs in your template that use illegal characters. They have been hidden.';}
	echo '</div>';}

	echo '<!--- Added by the Simple Extra Inputs plugin. --->'."\n";//	Create some tabs for each input.
	for($i=0;$i<=(count($SEI_TAB_LIST)-1);$i++){
	$tab_name = $SEI_TAB_LIST[$i];//					Get tab name.
	$active_tab = '';
	$shadow_details = 'inset 0px 2px 3px 0px #acacac';//			Make a fancy shadow for the selected tab.
	if($tab_name == $SEI_LAST_TAB){//					Make a special style for the active tab,
		$active_tab = $SEI_CURRENTLY_ACTIVE_TAB;//			and make the tab un-clickable.
		echo '<span><input class="submit" style="background:'.$active_tab.'; -webkit-box-shadow: '.$shadow_details.'; -moz-box-shadow:'.$shadow_details.'; box-shadow: '.$shadow_details.';" type="button" name="submitted" value="'.$tab_name.'" onclick="warnme=false;" /></span>';
	} else {
	echo '<span><input class="submit" type="submit" name="submitted" value="'.$tab_name.'" onclick="warnme=false;" /></span>';}
	}
	echo '<br/><br/><p>Clicking a Tab above will SAVE and switch inputs. You are currently editing: <strong><span style="color:green">'.$SEI_LAST_TAB.'</span></strong>.<br/>';
	echo 'If you change the Page Template, you will need to SAVE for your Tabs to update.</p><br/>';
}	/*-------------------------------------------------------------------------------*/

/*	----------------------------------------------------------------------------------
*	Intercepting the saving of the page file.
*	Extracting the users input data, and adding our own tags to it.
*	Sending back the result!
*	---------------------------------------------------------------------------------*/
function intercept_save_file(){
	global $xml;//								Hijack the page save file.
	if(isset($_POST['submitted'])){//					Probably pointless to check, but best to be safe.
		$last_tab = $_POST['lastpage-view'];//				Get the last tab that was open.
		if($_POST['submitted'] == 'Save Updates' || $_POST['submitted'] == 'Save Page'){
			$return_tab = $last_tab;//				Check to see if the page has just been saved
		} else {//							or if the tab has been changed.
			$return_tab = $_POST['submitted'];}//			Get the last tab viewed, so we can return there.
		$last = $xml->addChild('returnpage');//				Insert record of last tab viewed.
		$last->addCData($return_tab);

		$new_information = (string)$xml->content[0];//			Pull out the newly entered information.
		$old_information = scan_content_string($_POST['old-page-content']);//Original page information.
		if($old_information == false){//				Check to see if the page is fresh.
			$old_information = array($last_tab=>$new_information);
		} else {//							If the page is fresh, make a new tab else simply,
		$old_information[$last_tab] = $new_information;}//		insert the new information replacing the old.
		$save_info = '';//						Initialize our new data string.
		foreach($old_information as $k=>$v){//				Compile data back into single string.
			$each_tab = safe_slash_html('||]'.$k.'[||');//		Ensure the tab name is secure with safe_slash_html.
			$save_info .= $each_tab.$v;//				Put em together.
		}
		$xml->content[0] = '';//					Clear the XML data.
		$xml->content[0]->addCData($save_info);}//			Insert our altered information.
}	/*-------------------------------------------------------------------------------*/


/*	----------------------------------------------------------------------------------
*	Find and return the contents of a specified page / tab combination.
*	---------------------------------------------------------------------------------*/
function hunt_page_data($page,$tab='main'){
	if($tab == NULL){$tab = 'main';}//					Set default file.
	$file = getXML(GSDATAPAGESPATH . $page . '.xml');//			Find the page file and load it.
	$content = $file->content[0];//						Get the content from the file.
	$unpacked = scan_content_string($content);//				Extract the data from content.
	if($unpacked == false){return $content;}//				If no data, then leave content alone.
	$tab = bling($tab);
	if(array_key_exists($tab, $unpacked)){return $unpacked[$tab];}
	else { return 'Error 404: The content you requested doesn\'t exist.';}//Send back the data.
}	/*-------------------------------------------------------------------------------*/


/*	----------------------------------------------------------------------------------
*	Get a list of all pages.
*	---------------------------------------------------------------------------------*/
function list_all_pages(){
	$large_list = get_available_pages();
	for($i=0;$i<=(count($large_list)-1);$i++){
		$shortlist[$i] = bling($large_list[$i]['slug']);}
		return $shortlist;
}	/*-------------------------------------------------------------------------------*/


/*	----------------------------------------------------------------------------------
*	Parse the content data. Return values from ||] ... [|| Returns false if the string
*	does not yet have anything to parse.
*	---------------------------------------------------------------------------------*/
function scan_content_string($string){
$string_array = explode('||', $string);//					Break up our string.
$content = NULL;//								Set an empty data variable. Lets fill it!
$previous_tab = NULL;//								Set tab memory.
$array_location = 'Beginning';//						Set string location.
foreach($string_array as $item){//						Begin extracting the content data.
	if (substr($item,0,1) == ']' && substr($item,-1) == '['){ //		Is the current item a tab?
		$item = str_replace(']', '', $item);
		$item = str_replace('[', '', $item);//				Take out the ] [ characters.
		$content[$item] = '';
		$previous_tab = $item;//					Save this tab in the memory, for next string.
		$array_location = 'Tab';//					Where are we in the data? We are working with tabs.
	} else {//								Guess the item is not a tab...
		if ($array_location == 'Tab'){//				Last item was a tab. This must then be the data.
			$content[$previous_tab]=$item;//			Add content to the key of the previous tab.
			$array_location = 'Data';//				We are now in the data.
		} elseif($array_location == 'Data'){//				We are still in data. We accidentally grabbed ||.
			$content[$previous_tab].= '||'.$item;//			Put them back in. Clean up our messes.
		}}}//								If the first item was not a tab, we end ignore it.
	if($previous_tab == NULL){//						If no tabs were found, the page must
		return false;//							be either empty, or void of tab tags.
	} else { return $content; }//						Otherwise return the data!
}	/*-------------------------------------------------------------------------------*/


/*	----------------------------------------------------------------------------------
*	Parse the template file. Return values from within insert_page_content( ... );
*	Return "Main" if there are no calls to this plugin on the template.
*	---------------------------------------------------------------------------------*/
function scan_template($theme_folder,$theme_file){
	$template_url = GSTHEMESPATH . $theme_folder . '/' . $theme_file;//	Find the template file.
	$the_file = file_get_contents($template_url);//				And scan the file.
	preg_match_all("/<\?php.*?\binsert_page_content\('?\"?([^)]*?)'?\"?\);?.*?\?>/si", $the_file, $result_list);
	$length = count($result_list[0]);
	if ($length == 0){
		return array('Main');
	} else {
	return $result_list[1];}
}	/*-------------------------------------------------------------------------------*/

/*	----------------------------------------------------------------------------------
*	Make text look pretty. Gotta look presentable!
*	---------------------------------------------------------------------------------*/
function bling($text){
	return trim(ucwords(strtolower($text)));
}	/*-------------------------------------------------------------------------------*/


/*	----------------------------------------------------------------------------------
*	If someone calls get_page_content(), process content so they don't get garbage.
*	---------------------------------------------------------------------------------*/
function content_hostage($request){
	if(!array_key_exists('SEI_RAW_CONTENT_DATA', $GLOBALS)){//		If data was already pulled, don't process it again.
	global $SEI_RAW_CONTENT_DATA;//						Bring in the global variable.
	$SEI_RAW_CONTENT_DATA = scan_content_string($request);}//		Pull out the data from the content.
	else {global $SEI_RAW_CONTENT_DATA;}//					Bring in the global.
	if($SEI_RAW_CONTENT_DATA == false){//					If it can't get any data, content must be untouched.
		return $request;}//						So leave it alone.
	else if(array_key_exists('Main', $SEI_RAW_CONTENT_DATA)){//		Check if the content has the default tab "Main"
			return $SEI_RAW_CONTENT_DATA['Main'];}//		If so, send that out to them.
	else if(count($SEI_RAW_CONTENT_DATA)==1){
			return end($SEI_RAW_CONTENT_DATA);}
		else { return "Error 404: Text not found.";}//			If there is no content then send none.
}	/*-------------------------------------------------------------------------------*/?>